<template>
  <section>
    <div>
      <div
        class="d-flex flex-column flex-sm-row align-items-center justify-content-between mb-3"
      >
        <h4 class="text-capitalize">
          {{ route.params?.breed }} - {{ route.params?.subbreed }}
        </h4>
        <div
          class="d-flex align-items-baseline justify-content-center"
          style="gap: 12px"
        >
          <span>Show Number of Images</span>
          <div role="group">
            <b-form-input
              v-model="numberOfImages"
              :state="validNumber"
              placeholder="0"
              trim
              type="number"
              max="50"
              min="3"
              style="width: 100px"
            />
            <b-form-invalid-feedback>
              {{ Number(numberOfImages) > 50 ? 'Maximum 50' : 'Minimum 3' }}
            </b-form-invalid-feedback>
          </div>
        </div>
      </div>
      <div
        v-if="!['terrier', 'shiba'].includes(route.params?.breed)"
        class="image-list"
      >
        <div v-for="(image, index) in images" :key="`${image}-${index}`">
          <ImageGrid :image-src="image" hide-information is-sub-breed />
        </div>
      </div>
      <ImageSlider
        v-else-if="route.params?.breed === 'terrier'"
        :images="images.map((img) => ({ src: img }))"
        indicators
      />
      <vueper-slides
        v-else
        :visible-slides="3"
        :slide-ratio="1 / 4"
        slide-multiple
        :arrows-outside="false"
        :gap="3"
        fixed-height="300px"
      >
        <vueper-slide v-for="(image, i) in images" :key="i" :image="image" />
      </vueper-slides>
    </div>
  </section>
</template>

<script setup>
import { onMounted, useRoute, useStore } from '@nuxtjs/composition-api'
import { computed, ref, watch } from 'vue'

import { VueperSlides, VueperSlide } from 'vueperslides'
import 'vueperslides/dist/vueperslides.css'

const route = useRoute()
const store = useStore()

const numberOfImages = ref(3)
const images = ref([])

const validNumber = computed(
  () => Number(numberOfImages.value) >= 3 && Number(numberOfImages.value) <= 50
)

const fetchImages = async () => {
  const breed = route.value.params.breed
  const subBreed = route.value.params.subbreed
  images.value = await store.dispatch('dog/dog_fetchSubBreedImageUrl', {
    breed,
    subBreed,
    numberOfImages: numberOfImages.value,
  })
}

let timeout = 0

watch(numberOfImages, () => {
  clearTimeout(timeout)
  if (validNumber.value) {
    timeout = setTimeout(() => {
      fetchImages()
    }, 500)
  }
})

onMounted(() => {
  fetchImages()
})
</script>
